com.ihr.xbrl.om.table.definition

## Class XBRLAspectNode

- java.lang.Object
- - com.ihr.xbrl.om.XMLFragment
  - - com.ihr.xbrl.om.exLinks.XLinkElement
    - - com.ihr.xbrl.om.exLinks.XBRLPointerOfARelationship
      - - com.ihr.xbrl.om.exLinks.XBRLResource
        - - com.ihr.xbrl.om.table.XBRLTableResource
          - - com.ihr.xbrl.om.table.definition.XBRLDefinitionNode
            - - com.ihr.xbrl.om.table.definition.XBRLOpenDefinitionNode
              - - com.ihr.xbrl.om.table.definition.XBRLAspectNode

- All Implemented Interfaces:
    HasAdditionalEqualityForReassignation, XBRLRelationshipPoint, HasBreakdownTree, HasFilters, HasParentChildAttribute, HasTableProcessor, StaticCheck, Thinable, XBRLValidation, XBRLValueKey, XMLHasParent, java.lang.Cloneable, javax.xml.namespace.NamespaceContext

      public class XBRLAspectNode
      extends XBRLOpenDefinitionNode
      implements HasFilters, StaticCheck

  The Class XBRLAspectNode.
  Author:
    Ignacio

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.ihr.xbrl.om.table.HasParentChildAttribute

      `HasParentChildAttribute.ParentChildEnum`

    - ### Nested classes/interfaces inherited from interface com.ihr.xbrl.om.XBRLValidation

      `XBRLValidation.Direction`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static javax.xml.namespace.QName` | `conceptAspectPWD20130517` The Constant conceptAspect.
    `static javax.xml.namespace.QName` | `conceptAspectREC20140318` The Constant conceptAspectREC20140318.
    `static javax.xml.namespace.QName` | `dimensionAspectPWD20130517` The Constant dimensionAspect.
    `static javax.xml.namespace.QName` | `dimensionAspectREC20140318` The Constant dimensionAspectREC20140318.
    `static javax.xml.namespace.QName` | `entityIdentifierAspectPWD20130517` The Constant entityIdentifierAspect.
    `static javax.xml.namespace.QName` | `entityIdentifierAspectREC20140318` The Constant entityIdentifierAspectREC20140318.
    `static javax.xml.namespace.QName` | `includeUnreportedValue` The Constant includeUnreportedValue.
    `static javax.xml.namespace.QName` | `periodAspectPWD20130517` The Constant periodAspect.
    `static javax.xml.namespace.QName` | `periodAspectREC20140318` The Constant periodAspectREC20140318.
    `static javax.xml.namespace.QName` | `unitAspectPWD20130517` The Constant unitAspect.
    `static javax.xml.namespace.QName` | `unitAspectREC20140318` The Constant unitAspectREC20140318.

    - ### Fields inherited from class com.ihr.xbrl.om.table.definition.XBRLDefinitionNode

      `tagSelector`

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XBRLResource

      `log, nullResource`

    - ### Fields inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `actuate, ACTUATE, ARC, arcrole, ARCROLE, ETITLE, EXTENDED, from, FROM, href, HREF, label, LABEL, LOCATOR, RESOURCE, role, ROLE, show, SHOW, SIMPLE, title, TITLE, to, TO, TYPE`

    - ### Fields inherited from class com.ihr.xbrl.om.XMLFragment

      `CONCEPT_LABEL, CONCEPT_QNAME, EASY_TO_READ, ELEMENT_LABEL, EMPTYRELATIONSHIPSITERATORINSTANCE, EMPTYXMLFRAGMENTITERATORINSTANCE, FACT_CONCEPT_DATATYPE, FACT_CONCEPT_LABEL, FACT_QNAME, HIDE_COMMON_ACCURACY, idQName, NO_POSITION, OrderComparator, OrderComparator2, PERIOD_TYPE, PERIOD_VALUE, SHORT_TEXT, SOURCE_DOCUMENT, XPATH, XPOINTER`

    - ### Fields inherited from interface com.ihr.xbrl.om.table.HasParentChildAttribute

      `parentChilOrder`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XBRLAspectNode(XBRLTableProcessor xbrlTableProcessor, XBRLResource res)` Instantiates a new XBRL aspect node.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `allowRollUps()` Some nodes does not allow the creation of roll-up nodes. such as the aspect node.
    `int` | `getAspects()` Gets the aspect.
    `ConceptsAspectInterface` | `getConceptAspectResolver()` if this node defines the concept aspect this method returns the class that resolves the concept aspect otherwise this method returns null.
    `javax.xml.namespace.QName` | `getDimension()` Gets the dimension.
    `DimensionsAspectInterface<?>` | `getDimensionAspectResolver()` if this node defines the dimension aspect this method returns the class that resolves the dimension aspect otherwise this method returns null.
    `EntityIdentifiersAspectInterface` | `getEntityIdentifierAspectResolver()` if this node defines the entity aspect this method returns the class that resolves the entity aspect otherwise this method returns null.
    `java.util.Iterator<XBRLFilterUse>` | `getFilters()` Gets the filters.
    `java.util.Collection<net.sf.saxon.s9api.QName>` | `getParameterNames()` At this stage it is unsure this function is needed.
    `PeriodsAspectInterface` | `getPeriodAspectResolver()` if this node defines the period aspect this method returns the class that resolves the period aspect otherwise this method returns null.
    `UnitsAspectInterface` | `getUnitAspectResolver()` Gets the unit aspect resolver.
    `boolean` | `isAbstract()` Returns true if this is a closed definition node and is abstract.
    `boolean` | `isIncludeUnreportedValue()` access to the value of the includeUnreportedValue attribute.
    `void` | `staticCheck()` Resources that has static checking implements this interface.

    - ### Methods inherited from class com.ihr.xbrl.om.table.definition.XBRLOpenDefinitionNode

      `getNumberOfNodes`

    - ### Methods inherited from class com.ihr.xbrl.om.table.definition.XBRLDefinitionNode

      `getBreakdownTree, getParentChildOrder, getTagSelector, hasOpen, isLeaf, isOpen, isParentChildOrderDefined, readDefinitionNodeSubTree, resetTable`

    - ### Methods inherited from class com.ihr.xbrl.om.table.XBRLTableResource

      `getFPXPathCompiler, getProcessor, isSpecificationVersion`

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XBRLResource

      `addChild, clear, equals, generateLocatorToNode, generateNode, getAttributes, getDTSBase, getFriendlyName, getFriendlyName, getParent, getResourceIdentifier, getRoleType, getType, getValidationReport, getValueKey, hashCode, invalidate, invalidate, isComplexType, isOnValidation, isSimpleType, setComplexType, setDTSBase, setId, setParent, setRole, setRoleType, setSimpleType, setValue, validate`

    - ### Methods inherited from class com.ihr.xbrl.om.exLinks.XLinkElement

      `getActuate, getArcrole, getFromTxt, getHRef, getLabel, getRole, getShow, getStaticLabel, getSType, getTitle, getToTxt, isRequiredAttribute, isValidAttribute, setActuate, setArcrole, setFrom, setHRef, setLabel, setShow, setSType, setTitle, setTo`

    - ### Methods inherited from class com.ihr.xbrl.om.XMLFragment

      `addAttribute, addFromRelationship, addNamespace, addNamespace, addToRelationship, addXMLChild, changeBase, checkBase, clone, clone, delAttribute, delAttribute, equalXdmValues, evaluateBoolean, evaluateList, evaluateNode, evaluateNumber, evaluateString, generateId, generateNodeNamespacesAndAttributes, generateNodeValue, generatePrefix, getAllAttributes, getAttribute, getAttributeBooleanValue, getAttributeQNameValue, getAttributes, getAttributeStringValue, getAttributeValue, getBase, getBase, getBaseURI, getBooleanValue, getChild, getContainer, getContainerDocumentURI, getDeclaredNamespaces, getDocument, getElements, getElementsHashCode, getFragment, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getFromRelationships, getGenericLabelText, getId, getLang, getNamespaceURI, getNodeName, getNumberOfAttributes, getNumberOfElements, getNumberOfFromRelationships, getNumberOfToRelationships, getOrGenerateId, getPrefix, getPrefixes, getQNameValue, getRelationshipsBases, getRelationshipsChain, getRelationshipTypes, getStaticContext, getStaticNamespace, getStringValue, getToolTipText, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getToRelationships, getValue, getXPathExecutable, getXPathNamespaceContext, getXPathToNode, getXPathToRoot, getXPointerElementScheme, getXPointerElementScheme, getXPointerShorthandScheme, getXPointerToNode, isDead, isNamespaceDefined, isXdmDocumentAttached, objEquals, objHashCode, qNameToString, removeAttribute, removeChild, removeChild, removeFromRelationship, removeToRelationship, removeXMLChild, resetElements, resetHash, resolve_equal2, resolveHRef, resolveHRef, s_equal2, s_equal2, s_equal2, setAttributes, setBase, setDocument, setDocumentAndReload, setElements, setLang, setNamespaceContext, setNamespaces, setNode, setNodeName, setParent, setRegenerateNodeIfnotFound, setValue, setVariablesDefined, size, thin, toString, valueEquals, xEqual`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.ihr.xbrl.om.exLinks.XBRLRelationshipPoint

      `addFromRelationship, addToRelationship, getFromRelationships, getToRelationships, removeFromRelationship, removeToRelationship`

- - ### Field Detail

    - #### includeUnreportedValue

          public static final javax.xml.namespace.QName includeUnreportedValue

      The Constant includeUnreportedValue.

    - #### conceptAspectPWD20130517

          public static final javax.xml.namespace.QName conceptAspectPWD20130517

      The Constant conceptAspect.

    - #### conceptAspectREC20140318

          public static final javax.xml.namespace.QName conceptAspectREC20140318

      The Constant conceptAspectREC20140318.

    - #### unitAspectPWD20130517

          public static final javax.xml.namespace.QName unitAspectPWD20130517

      The Constant unitAspect.

    - #### unitAspectREC20140318

          public static final javax.xml.namespace.QName unitAspectREC20140318

      The Constant unitAspectREC20140318.

    - #### entityIdentifierAspectPWD20130517

          public static final javax.xml.namespace.QName entityIdentifierAspectPWD20130517

      The Constant entityIdentifierAspect.

    - #### entityIdentifierAspectREC20140318

          public static final javax.xml.namespace.QName entityIdentifierAspectREC20140318

      The Constant entityIdentifierAspectREC20140318.

    - #### periodAspectPWD20130517

          public static final javax.xml.namespace.QName periodAspectPWD20130517

      The Constant periodAspect.

    - #### periodAspectREC20140318

          public static final javax.xml.namespace.QName periodAspectREC20140318

      The Constant periodAspectREC20140318.

    - #### dimensionAspectPWD20130517

          public static final javax.xml.namespace.QName dimensionAspectPWD20130517

      The Constant dimensionAspect.

    - #### dimensionAspectREC20140318

          public static final javax.xml.namespace.QName dimensionAspectREC20140318

      The Constant dimensionAspectREC20140318.

  - ### Constructor Detail

    - #### XBRLAspectNode

          public XBRLAspectNode(XBRLTableProcessor xbrlTableProcessor,
                        XBRLResource res)
                         throws XTValidationException

      Instantiates a new XBRL aspect node.
      Parameters:
        `xbrlTableProcessor` - the xbrl table processor
        `res` - the res
      Throws:
        `XTValidationException` - the XT validation exception

  - ### Method Detail

    - #### isIncludeUnreportedValue

          public boolean isIncludeUnreportedValue()

      Description copied from class: `XBRLOpenDefinitionNode`
      access to the value of the includeUnreportedValue attribute.
      Specified by:
        `isIncludeUnreportedValue` in class `XBRLOpenDefinitionNode`
      Returns:
        true, if is include unreported value

    - #### getFilters

          public java.util.Iterator<XBRLFilterUse> getFilters()

      Gets the filters.
      Specified by:
        `getFilters` in interface `HasFilters`
      Returns:
        the vFilters

    - #### getAspects

          public int getAspects()

      Gets the aspect.
      Returns:
        the aspect

    - #### getDimension

          public javax.xml.namespace.QName getDimension()

      Gets the dimension.
      Returns:
        the dimension

    - #### getConceptAspectResolver

          public ConceptsAspectInterface getConceptAspectResolver()

      if this node defines the concept aspect this method returns the class that resolves the concept aspect otherwise this method returns null.
      Returns:
        the conceptAspectResolver
      See Also:
        `getAspects()`

    - #### getDimensionAspectResolver

          public DimensionsAspectInterface<?> getDimensionAspectResolver()

      if this node defines the dimension aspect this method returns the class that resolves the dimension aspect otherwise this method returns null.
      Returns:
        the dimensionResolver
      See Also:
        `getAspects()`

    - #### getPeriodAspectResolver

          public PeriodsAspectInterface getPeriodAspectResolver()

      if this node defines the period aspect this method returns the class that resolves the period aspect otherwise this method returns null.
      Returns:
        the periodAspectResolver
      See Also:
        `getAspects()`

    - #### getUnitAspectResolver

          public UnitsAspectInterface getUnitAspectResolver()

      Gets the unit aspect resolver.
      Returns:
        the unit aspect resolver

    - #### getEntityIdentifierAspectResolver

          public EntityIdentifiersAspectInterface getEntityIdentifierAspectResolver()

      if this node defines the entity aspect this method returns the class that resolves the entity aspect otherwise this method returns null.
      Returns:
        the entityIdentifierAspectResolver
      See Also:
        `getAspects()`

    - #### getParameterNames

          public java.util.Collection<net.sf.saxon.s9api.QName> getParameterNames()

      Description copied from interface: `HasFilters`
      At this stage it is unsure this function is needed.
      Specified by:
        `getParameterNames` in interface `HasFilters`
      Returns:
        the parameter names

    - #### isAbstract

          public boolean isAbstract()

      Description copied from class: `XBRLDefinitionNode`
      Returns true if this is a closed definition node and is abstract.
      Specified by:
        `isAbstract` in class `XBRLDefinitionNode`
      Returns:
        boolean value

    - #### allowRollUps

          public boolean allowRollUps()

      Description copied from class: `XBRLDefinitionNode`
      Some nodes does not allow the creation of roll-up nodes. such as the aspect node. Others do allow.
      Specified by:
        `allowRollUps` in class `XBRLDefinitionNode`
      Returns:
        true, if successful

    - #### staticCheck

          public void staticCheck()
                           throws XTValidationException,
                                  XFValidationException

      Description copied from interface: `StaticCheck`
      Resources that has static checking implements this interface. During resource compilation time the static check is evaluated.

      In case of errors, the staticCheck method raises XTValidationException

      Specified by:
        `staticCheck` in interface `StaticCheck`
      Throws:
        `XTValidationException` - if static errors occurs
        `XFValidationException` - if static errors occurs and the error is defined in the formula specification